// TJC implementation of procedure compileproc_string_is_java_double
package tjc;
import tcl.lang.*;

public class CompileprocStringIsJavaDoubleCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 7, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        ExprValue evs2 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "tstr");
        }
        setVarScalar(interp, "tstr", objv[1], compiledLocals, 0);
        { // Invoke: if ... ...
            // Binary operator: () || ()
            // Binary operator: $tstr == ""
            TclObject tmp0 = getVarScalar(interp, "tstr", compiledLocals, 0);
            ExprValue tmp1 = evs0;
            TJC.exprEqualsEmptyString(tmp1, tmp0, false);
            // End Binary operator: ==
            if (!tmp1.getBooleanValue(interp)) {
            // Unary operator: ! [...]
            { // Invoke: string is double $tstr
                TclObject[] objv2 = TJC.grabObjv(interp, 4);
                TclObject tmp3;
                try {
                    // Arg 0 constant: string
                    objv2[0] = const0;
                    // Arg 1 constant: is
                    objv2[1] = const1;
                    // Arg 2 constant: double
                    objv2[2] = const2;
                    // Arg 3 variable: $tstr
                    tmp3 = getVarScalar(interp, "tstr", compiledLocals, 0);
                    tmp3.preserve();
                    objv2[3] = tmp3;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv2, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp3 = objv2[3];
                    if ( tmp3 != null ) {
                        tmp3.release();
                    }
                    TJC.releaseObjv(interp, objv2, 4);
                }
            } // End Invoke: string
            TclObject tmp4 = interp.getResult();
            ExprValue tmp5 = evs1;
            if ( tmp4.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp5, tmp4);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp5, tmp4);
            }
            // End Unary operator: !
            tmp1.setIntValue(tmp5.getBooleanValue(interp));
            } else {
            tmp1.setIntValue(1);
            } // End if: !()
            // End Binary operator: ||
            boolean tmp6 = ( tmp1.getIntValue() != 0 );
            if ( tmp6 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const3);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set has_decimal [...]
            TclObject tmp7;
            { // Invoke: expr ...
                // Binary operator: [...] != ()
                { // Invoke: string first "." $tstr
                    char tmp8 = '.';
                    TclObject tmp9 = getVarScalar(interp, "tstr", compiledLocals, 0);
                    String tmp10 = tmp9.toString();
                    int tmp11 = tmp10.indexOf(tmp8);
                    interp.setResult(tmp11);
                } // End Invoke: string
                TclObject tmp12 = interp.getResult();
                ExprValue tmp13 = evs0;
                TJC.exprInitValue(interp, tmp13, tmp12);
                // Unary operator: - 1
                ExprValue tmp14 = evs1;
                tmp14.setIntValue(-1);
                // End Unary operator: -
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp13, tmp14);
                // End Binary operator: !=
                interp.setResult( tmp13.getIntValue() != 0 );
            } // End Invoke: expr
            tmp7 = interp.getResult();
            setVarScalar(interp, "has_decimal", tmp7, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: set has_exp [...]
            TclObject tmp15;
            { // Invoke: expr ...
                // Binary operator: [...] != ()
                { // Invoke: string first "e" $tstr
                    char tmp16 = 'e';
                    TclObject tmp17 = getVarScalar(interp, "tstr", compiledLocals, 0);
                    String tmp18 = tmp17.toString();
                    int tmp19 = tmp18.indexOf(tmp16);
                    interp.setResult(tmp19);
                } // End Invoke: string
                TclObject tmp20 = interp.getResult();
                ExprValue tmp21 = evs0;
                TJC.exprInitValue(interp, tmp21, tmp20);
                // Unary operator: - 1
                ExprValue tmp22 = evs1;
                tmp22.setIntValue(-1);
                // End Unary operator: -
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp21, tmp22);
                // End Binary operator: !=
                interp.setResult( tmp21.getIntValue() != 0 );
            } // End Invoke: expr
            tmp15 = interp.getResult();
            setVarScalar(interp, "has_exp", tmp15, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: if ... ... else ...
            // Binary operator: $has_decimal || ()
            TclObject tmp23 = getVarScalar(interp, "has_decimal", compiledLocals, 1);
            ExprValue tmp24 = evs0;
            TJC.exprInitValue(interp, tmp24, tmp23);
            if (!tmp24.getBooleanValue(interp)) {
            // Binary operator: () && $has_exp
            // Unary operator: ! $has_decimal
            TclObject tmp25 = getVarScalar(interp, "has_decimal", compiledLocals, 1);
            ExprValue tmp26 = evs1;
            if ( tmp25.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp26, tmp25);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp26, tmp25);
            }
            // End Unary operator: !
            if (tmp26.getBooleanValue(interp)) {
            TclObject tmp27 = getVarScalar(interp, "has_exp", compiledLocals, 2);
            ExprValue tmp28 = evs2;
            TJC.exprInitValue(interp, tmp28, tmp27);
            tmp26.setIntValue(tmp28.getBooleanValue(interp));
            } else {
            tmp26.setIntValue(0);
            } // End if: ()
            // End Binary operator: &&
            tmp24.setIntValue(tmp26.getBooleanValue(interp));
            } else {
            tmp24.setIntValue(1);
            } // End if: !$has_decimal
            // End Binary operator: ||
            boolean tmp29 = ( tmp24.getIntValue() != 0 );
            if ( tmp29 ) {
            } else {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const3);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: if {0} ...
            if ( false ) {
                { // Invoke: set dmin1 -4.9e-324
                    setVarScalar(interp, "dmin1", const4, compiledLocals, 3);
                } // End Invoke: set
                { // Invoke: set dmin2 4.9e-324
                    setVarScalar(interp, "dmin2", const5, compiledLocals, 4);
                } // End Invoke: set
                { // Invoke: if {$tstr < $dmin1} ...
                    // Binary operator: $tstr < $dmin1
                    TclObject tmp30 = getVarScalar(interp, "tstr", compiledLocals, 0);
                    ExprValue tmp31 = evs0;
                    TJC.exprInitValue(interp, tmp31, tmp30);
                    TclObject tmp32 = getVarScalar(interp, "dmin1", compiledLocals, 3);
                    ExprValue tmp33 = evs1;
                    TJC.exprInitValue(interp, tmp33, tmp32);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp31, tmp33);
                    // End Binary operator: <
                    boolean tmp34 = ( tmp31.getIntValue() != 0 );
                    if ( tmp34 ) {
                        { // Invoke: puts "..."
                            TclObject[] objv35 = TJC.grabObjv(interp, 2);
                            TclObject tmp36;
                            try {
                                // Arg 0 constant: puts
                                objv35[0] = const6;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp37 = new StringBuffer(64);
                                tmp36 = getVarScalar(interp, "tstr", compiledLocals, 0);
                                sbtmp37.append(tmp36.toString());
                                sbtmp37.append(" is smaller than ");
                                tmp36 = getVarScalar(interp, "dmin1", compiledLocals, 3);
                                sbtmp37.append(tmp36.toString());
                                tmp36 = TclString.newInstance(sbtmp37);
                                tmp36.preserve();
                                objv35[1] = tmp36;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv35, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                tmp36 = objv35[1];
                                if ( tmp36 != null ) {
                                    tmp36.release();
                                }
                                TJC.releaseObjv(interp, objv35, 2);
                            }
                        } // End Invoke: puts
                        { // Invoke: return 0
                            interp.resetResult();
                            interp.setResult(const3);
                            if ( true ) { return; }
                        } // End Invoke: return
                    }
                } // End Invoke: if
                { // Invoke: if {$tstr < $dmin2} ...
                    // Binary operator: $tstr < $dmin2
                    TclObject tmp38 = getVarScalar(interp, "tstr", compiledLocals, 0);
                    ExprValue tmp39 = evs0;
                    TJC.exprInitValue(interp, tmp39, tmp38);
                    TclObject tmp40 = getVarScalar(interp, "dmin2", compiledLocals, 4);
                    ExprValue tmp41 = evs1;
                    TJC.exprInitValue(interp, tmp41, tmp40);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp39, tmp41);
                    // End Binary operator: <
                    boolean tmp42 = ( tmp39.getIntValue() != 0 );
                    if ( tmp42 ) {
                        { // Invoke: puts "..."
                            TclObject[] objv43 = TJC.grabObjv(interp, 2);
                            TclObject tmp44;
                            try {
                                // Arg 0 constant: puts
                                objv43[0] = const6;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp45 = new StringBuffer(64);
                                tmp44 = getVarScalar(interp, "tstr", compiledLocals, 0);
                                sbtmp45.append(tmp44.toString());
                                sbtmp45.append(" is smaller than ");
                                tmp44 = getVarScalar(interp, "dmin2", compiledLocals, 4);
                                sbtmp45.append(tmp44.toString());
                                tmp44 = TclString.newInstance(sbtmp45);
                                tmp44.preserve();
                                objv43[1] = tmp44;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv43, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                tmp44 = objv43[1];
                                if ( tmp44 != null ) {
                                    tmp44.release();
                                }
                                TJC.releaseObjv(interp, objv43, 2);
                            }
                        } // End Invoke: puts
                        { // Invoke: return 0
                            interp.resetResult();
                            interp.setResult(const3);
                            if ( true ) { return; }
                        } // End Invoke: return
                    }
                } // End Invoke: if
                { // Invoke: set dmax1 ...
                    setVarScalar(interp, "dmax1", const7, compiledLocals, 5);
                } // End Invoke: set
                { // Invoke: set dmax2 ...
                    setVarScalar(interp, "dmax2", const8, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: if {$tstr > $dmax1} ...
                    // Binary operator: $tstr > $dmax1
                    TclObject tmp46 = getVarScalar(interp, "tstr", compiledLocals, 0);
                    ExprValue tmp47 = evs0;
                    TJC.exprInitValue(interp, tmp47, tmp46);
                    TclObject tmp48 = getVarScalar(interp, "dmax1", compiledLocals, 5);
                    ExprValue tmp49 = evs1;
                    TJC.exprInitValue(interp, tmp49, tmp48);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp47, tmp49);
                    // End Binary operator: >
                    boolean tmp50 = ( tmp47.getIntValue() != 0 );
                    if ( tmp50 ) {
                        { // Invoke: puts "..."
                            TclObject[] objv51 = TJC.grabObjv(interp, 2);
                            TclObject tmp52;
                            try {
                                // Arg 0 constant: puts
                                objv51[0] = const6;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp53 = new StringBuffer(64);
                                tmp52 = getVarScalar(interp, "tstr", compiledLocals, 0);
                                sbtmp53.append(tmp52.toString());
                                sbtmp53.append(" is larger than ");
                                tmp52 = getVarScalar(interp, "dmax1", compiledLocals, 5);
                                sbtmp53.append(tmp52.toString());
                                tmp52 = TclString.newInstance(sbtmp53);
                                tmp52.preserve();
                                objv51[1] = tmp52;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv51, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                tmp52 = objv51[1];
                                if ( tmp52 != null ) {
                                    tmp52.release();
                                }
                                TJC.releaseObjv(interp, objv51, 2);
                            }
                        } // End Invoke: puts
                        { // Invoke: return 0
                            interp.resetResult();
                            interp.setResult(const3);
                            if ( true ) { return; }
                        } // End Invoke: return
                    }
                } // End Invoke: if
                { // Invoke: if {$tstr > $dmax2} ...
                    // Binary operator: $tstr > $dmax2
                    TclObject tmp54 = getVarScalar(interp, "tstr", compiledLocals, 0);
                    ExprValue tmp55 = evs0;
                    TJC.exprInitValue(interp, tmp55, tmp54);
                    TclObject tmp56 = getVarScalar(interp, "dmax2", compiledLocals, 6);
                    ExprValue tmp57 = evs1;
                    TJC.exprInitValue(interp, tmp57, tmp56);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp55, tmp57);
                    // End Binary operator: >
                    boolean tmp58 = ( tmp55.getIntValue() != 0 );
                    if ( tmp58 ) {
                        { // Invoke: puts "..."
                            TclObject[] objv59 = TJC.grabObjv(interp, 2);
                            TclObject tmp60;
                            try {
                                // Arg 0 constant: puts
                                objv59[0] = const6;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp61 = new StringBuffer(64);
                                tmp60 = getVarScalar(interp, "tstr", compiledLocals, 0);
                                sbtmp61.append(tmp60.toString());
                                sbtmp61.append(" is larger than ");
                                tmp60 = getVarScalar(interp, "dmax2", compiledLocals, 6);
                                sbtmp61.append(tmp60.toString());
                                tmp60 = TclString.newInstance(sbtmp61);
                                tmp60.preserve();
                                objv59[1] = tmp60;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv59, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                tmp60 = objv59[1];
                                if ( tmp60 != null ) {
                                    tmp60.release();
                                }
                                TJC.releaseObjv(interp, objv59, 2);
                            }
                        } // End Invoke: puts
                        { // Invoke: return 0
                            interp.resetResult();
                            interp.setResult(const3);
                            if ( true ) { return; }
                        } // End Invoke: return
                    }
                } // End Invoke: if
            }
        } // End Invoke: if
        { // Invoke: return 1
            interp.resetResult();
            interp.setResult(const9);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_string_is_java_double");
        } finally {
            TJC.exprReleaseValue(interp, evs2);
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("string");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("is");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("double");
        const2.preserve(); const2.preserve();
        const3 = TclInteger.newInstance(0);
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("-4.9e-324");
        TclDouble.get(interp, const4);
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("4.9e-324");
        TclDouble.get(interp, const5);
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("puts");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("-1.7976931348623157e+308");
        TclDouble.get(interp, const7);
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("1.7976931348623157e+308");
        TclDouble.get(interp, const8);
        const8.preserve(); const8.preserve();
        const9 = TclInteger.newInstance(1);
        const9.preserve(); const9.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "string";
                break;
            }
            case 2: {
                cmdName = "puts";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "tstr",
        "has_decimal",
        "has_exp",
        "dmin1",
        "dmin2",
        "dmax1",
        "dmax2"
    };
} // end class CompileprocStringIsJavaDoubleCmd

