// TJC implementation of procedure descend_container_switch_is_switch_mode
package tjc;
import tcl.lang.*;

public class DescendContainerSwitchIsSwitchModeCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 2, compiledLocalsNames);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "option_str");
        }
        setVarScalar(interp, "option_str", objv[1], compiledLocals, 0);
        { // Invoke: set option ""
            setVarScalar(interp, "option", const0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: switch -exact -- $option_str {-e} - {-ex} - {-exa} - {-exac} - {-exact} ... {-g} - {-gl} - {-glo} - {-glob} ... {-r} - {-re} - {-reg} - {-rege} - {-regex} - {-regexp} ...
            TclObject tmp0 = getVarScalar(interp, "option_str", compiledLocals, 0);
            String tmp1 = tmp0.toString();
            int tmp1_length = tmp1.length();
            char tmp1_first = '\n';
            if ( tmp1_length > 0 ) {
                tmp1_first = tmp1.charAt(0);
            }
            if ( ( tmp1_length == 2 && tmp1_first == '-'
                    && tmp1.compareTo("-e") == 0 ) ||
                ( tmp1_length == 3 && tmp1_first == '-'
                    && tmp1.compareTo("-ex") == 0 ) ||
                ( tmp1_length == 4 && tmp1_first == '-'
                    && tmp1.compareTo("-exa") == 0 ) ||
                ( tmp1_length == 5 && tmp1_first == '-'
                    && tmp1.compareTo("-exac") == 0 ) ||
                ( tmp1_length == 6 && tmp1_first == '-'
                    && tmp1.compareTo("-exact") == 0 ) ) {
                // Pattern {-exact}
                { // Invoke: set option "exact"
                    setVarScalar(interp, "option", const1, compiledLocals, 1);
                } // End Invoke: set
            } else if ( ( tmp1_length == 2 && tmp1_first == '-'
                    && tmp1.compareTo("-g") == 0 ) ||
                ( tmp1_length == 3 && tmp1_first == '-'
                    && tmp1.compareTo("-gl") == 0 ) ||
                ( tmp1_length == 4 && tmp1_first == '-'
                    && tmp1.compareTo("-glo") == 0 ) ||
                ( tmp1_length == 5 && tmp1_first == '-'
                    && tmp1.compareTo("-glob") == 0 ) ) {
                // Pattern {-glob}
                { // Invoke: set option "glob"
                    setVarScalar(interp, "option", const2, compiledLocals, 1);
                } // End Invoke: set
            } else if ( ( tmp1_length == 2 && tmp1_first == '-'
                    && tmp1.compareTo("-r") == 0 ) ||
                ( tmp1_length == 3 && tmp1_first == '-'
                    && tmp1.compareTo("-re") == 0 ) ||
                ( tmp1_length == 4 && tmp1_first == '-'
                    && tmp1.compareTo("-reg") == 0 ) ||
                ( tmp1_length == 5 && tmp1_first == '-'
                    && tmp1.compareTo("-rege") == 0 ) ||
                ( tmp1_length == 6 && tmp1_first == '-'
                    && tmp1.compareTo("-regex") == 0 ) ||
                ( tmp1_length == 7 && tmp1_first == '-'
                    && tmp1.compareTo("-regexp") == 0 ) ) {
                // Pattern {-regexp}
                { // Invoke: set option "regexp"
                    setVarScalar(interp, "option", const3, compiledLocals, 1);
                } // End Invoke: set
            }
        } // End Invoke: switch
        { // Invoke: return $option
            TclObject tmp2 = getVarScalar(interp, "option", compiledLocals, 1);
            interp.resetResult();
            interp.setResult(tmp2);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_container_switch_is_switch_mode");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("exact");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("glob");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("regexp");
        const3.preserve(); const3.preserve();
    }

    String[] compiledLocalsNames = {
        "option_str",
        "option"
    };
} // end class DescendContainerSwitchIsSwitchModeCmd

