
library ieee;
use ieee.std_logic_1164.all;

entity component_inst is
	port(  in1, in2: std_logic_vector(3 downto 0 ); 
               out1, out2, out3 : out std_logic_vector(3 downto 0 ) );
end entity;

architecture rtl of component_inst is
	component comp1 is
		generic( g1, g2: integer := 5 );
		port( i1, i2: std_logic_vector(3 downto 0 ); o1: out std_logic_vector(3 downto 0 ) );
	end component;
begin
	inst1: comp1 
		generic map ( g1 => 2, g2 => 3 )
		port map ( i2 => in1, i1 => in2,
                   o1 => out1 );
	inst2: comp1 
		generic map ( 7, 8 )
		port map ( in1, in2, out2 );

--	inst3: comp1 
--		generic map ( g1 => 2, g2 => 3 )
--		port map ( i2( 3 downto 1) => in1(3 downto 1), i2(0) => in1(0),
--                           i1 => in2, o1 => out3 );
end;
